<?php
/*------------------------------------------------------------------------
# com_cb_report - Create User Report for Community Builder
# ------------------------------------------------------------------------
# author    Vsmart Extensions
# copyright Copyright (C) 2010 www.vsmart-extensions.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.vsmart-extensions.com
# Technical Support:  Forum - http://www.vsmart-extensions.com
-------------------------------------------------------------------------*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

class cb_reportController extends JController
{

	/**
	 * Custom Constructor
	 */
	function __construct( $default = array())
	{
		parent::__construct( $default );
	}
	
	function execute($task){
		switch($task){
			case "viewReport":
				$this->viewReport();
				break;
			case "showViewReport":
				$this->showViewReport();
				break;
			case "step1":
			case "add":
			case "edit":
				$this->displayItem();
				break;
			case  "cancel":
				$this->cancel();
				break;
			case "save":
				$this->save();
				break;
			case "public":
			case "unpublic":
				$this->publicItem();
				break;
			case "remove":
				$this->delete();
				break;
			case "publish":
			case "unpublish":
				$this->publish($task);
				break;
			case "getUsers":
				$this->getUsers();
				break;
			case "step2":
			case "configure_display":
				$this->configureDisplay();
				break;
			case "unpublishField":
			case "publishField":
				$this->publishField($task);
				break;
			case "step3":
				$this->finishReport();
				break;
			case "save_report":
				$this->completeReport();
				break;
			case "export_cvs":
				$this->exportCvs();
				break;
			case "orderupField":
				$did        = JRequest::getVar( 'did', array(), 'post', 'array' );
				$this->orderFields( $did[0], -1);
				break;
			case "orderdownField":
				$did        = JRequest::getVar( 'did', array(), 'post', 'array' );
				$this->orderFields( $did[0], 1);
				break;
			case "savefieldorder":
				$order      = JRequest::getVar( 'order', array(), 'post', 'array' );
				$this->orderAllFields($order);
				break;
			case "showEmailForm":
				$id      = JRequest::getVar( 'id', 0);
				$this->showEmailForm($id);
				break;
			case "testmail":
				$this->testMail();
				break;
			case "sendmail":
				$this->sendMail();
				break;
			default:
				$this->display();
				break;
		}
	}
	/**
	 * Cancel operation
	 */
	function cancel(){
		
		$model = &JModel::getInstance( 'cb_reportComponentModel' );
	   	$report = $model->getItem($id);
		
		if($report->title =="")
			$this->delete("NOTSHOW");
		$this->setRedirect( 'index.php?option=com_cb_report&controller=cb_report' );
	}
	function display() {
	   $model = &JModel::getInstance( 'cb_reportComponentModel' );
	   $model->getListItem();
	   $view = new cb_reportComponentView( );
	   $view->setModel( $model, true );
	   $view->display();
  }
  function showEmailForm($id) {
	   $emailConfigModel = &JModel::getInstance( 'cb_reportConfigEmailComponentModel' );
	   $emailConfigModel->getEmailConfig();
	   $emailConfig = $emailConfigModel->item;
	   
	   $model = &JModel::getInstance( 'cb_reportComponentModel' );
	   $report = $model->getItem($id);
	   
	   $view = new cb_reportComponentView( );
	   $GLOBALS['report'] = $report;
	   $view->displayEmailForm($id,$emailConfig,$report);
  } 
  function displayItem($id=0){
  		global $mainframe;
	   //get Config
	   $modelConfig = &JModel::getInstance( 'cb_reportConfigComponentModel' );
	   $fields = $modelConfig->getAllCBFields();

  	   $model = &JModel::getInstance( 'cb_reportComponentModel' );
	   $report = $model->getItem($id);
	   
	   $view = new cb_reportComponentView();
	   
	   $db = &JFactory::getDBO();
	   
	   $groups = explode(",",$report->cb_groups);

	   $acl		=& JFactory::getACL();
	   $gtree = $acl->get_group_children_tree( null, 'USERS', false );
		
	   $lists['gid'] 	= JHTML::_('select.genericlist',   $gtree, 'gid[]', 'size="10" multiple="multiple"', 'value', 'text', $groups );
	   $lists['order_Dir'] = $filter_order_Dir;
	   $lists['order']		= $filter_order;
	   
	   //Get Users
	   $users = array();
	   if($report->id){
		   $data   = $model->getSearchDate($report->id);
		   $data["gid"] = $report->cb_groups;
		   $users = $model->getUsers($data,$fields,$pagination);
		}
	   $view->displayItem($report,$lists,$fields,$users,$pagination);
  }
  function save(){
  	$modelConfig = &JModel::getInstance( 'cb_reportConfigComponentModel' );
	$fields = $modelConfig->getAllCBFields();
	
  	$model = &JModel::getInstance( 'cb_reportComponentModel' );
	$currentId = $model->saveReport($fields);
	
	$this->setRedirect( 'index.php?option=com_cb_report&controller=cb_report&task=configure_display&id='.$currentId);
  }
  function configureDisplay(){
  
  	$filter_order		= JRequest::getVar( 'filter_order_field', 'f.ordering', 'post', 'string' );
	$filter_order_Dir	= JRequest::getVar( 'filter_order_Dir_field', 'asc', 'post', 'string' );
	
  	$modelConfig = &JModel::getInstance( 'cb_reportConfigComponentModel' );
	
	$fields = $modelConfig->getAllCBFields2();
	
	$id		= JRequest::getVar('id',0);
	
	$model = &JModel::getInstance( 'cb_reportComponentModel' );
	
  	$displayFields = $model->getDisplayFields($fields,$id);
	
	$lists['order_Dir'] = $filter_order_Dir;
	$lists['order']		= $filter_order;
	
	$view = new cb_reportComponentView();
	
	$view->displayConfigure($displayFields,$id,$lists);
	
  }
  function finishReport(){
  
  	$id		= JRequest::getVar('id',0);
	$model = &JModel::getInstance( 'cb_reportComponentModel' );
	$report = $model->getItem($id);
	
	$db = &JFactory::getDBO();
	$query = "SELECT id as value, name as text FROM #__groups";
	$db->setQuery($query);
	$gtree = $db->loadObjectList();
	
	$lists['access'] 	= JHTML::_('select.genericlist',   $gtree, 'access', 'size="10"', 'value', 'text', $report->access );
	

   /* $acl		=& JFactory::getACL();
   $gtree = $acl->get_group_children_tree( null, 'USERS', false );
	
   $lists['access'] 	= JHTML::_('select.genericlist',   $gtree, 'gid[]', 'size="10" multiple="multiple"', 'value', 'text', $report->access ); */
	
	
	$view = new cb_reportComponentView();
	$view->finishReport($report,$lists,$id);
	
  }
  function completeReport(){
  
  	$model = &JModel::getInstance( 'cb_reportComponentModel' );
	$model->saveCompleteReport();
	
  	$this->setRedirect( 'index.php?option=com_cb_report&controller=cb_report' );
  }
  function exportCvs(){
  	$model = &JModel::getInstance( 'cb_reportComponentModel' );
	$model->exportCvs();
  }
  function viewReport(){
  	$model = &JModel::getInstance( 'cb_reportComponentModel' );
	$model->viewReport();
  }
  function showViewReport(){
  
  	global $mainframe;
	
  	$id		= JRequest::getVar('id',0);
	
	$limit		= JRequest::getVar( 'limit', $mainframe->getCfg('list_limit'), 'post', 'int' );
	$limitstart	= JRequest::getVar( 'limitstart', 0, 'post', 'int' );
	
  	$model = &JModel::getInstance( 'cb_reportComponentModel' );
	$report = $model->getItem($id);

  	$view = new cb_reportComponentView();
	$view->showViewReport($report,$id,$limit,$limitstart);
  }
  function publish($task){
	$model = &JModel::getInstance( 'cb_reportComponentModel' );
	$model->publish($task);
	$msg = JText::sprintf( 'Successfully Updated Items');
	$this->setRedirect( 'index.php?option=com_cb_report&controller=cb_report', $msg );
  }
  function delete($msg=""){
  	$model = &JModel::getInstance( 'cb_reportComponentModel' );
	$model->deleteListItem();
	if($msg !="NOTSHOW"){
		$msg = JText::sprintf( 'Successfully Deleted Items');
	}else{
		$msg = "";
	}
	$this->setRedirect( 'index.php?option=com_cb_report&controller=cb_report', $msg );
  }
  function getUsers(){
  	global $mainframe,$option;
	
	$filter_order		= JRequest::getVar( 'filter_order', 'u.name', 'post', 'string' );
	$filter_order_Dir	= JRequest::getVar( 'filter_order_Dir', 'asc', 'post', 'string' );
		
  	$post = JRequest::get('post');
  	$modelConfig = &JModel::getInstance( 'cb_reportConfigComponentModel' );
	$fields = $modelConfig->getAllCBFields();
	   
  	$model = &JModel::getInstance( 'cb_reportComponentModel' );
	$users = $model->getUsers($post,$fields,$pagination);
	if(count($users) > 0){
	?>
    <table class="adminlist" cellpadding="1">
		<thead>
			<tr>
				<th width="2%" class="title">
					<?php echo JText::_( 'NUM' ); ?>
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort',   'Name', 'u.name', @$filter_order_Dir, @$filter_order ); ?>
				</th>
				<th width="15%" class="title" nowrap="nowrap">
                    <?php echo JHTML::_('grid.sort',   'Username', 'u.username', @$filter_order_Dir, @$filter_order ); ?>
				</th>
                <th width="15%" class="title" nowrap="nowrap">
                    <?php echo JHTML::_('grid.sort',   'Email', 'u.email', @$filter_order_Dir, @$filter_order ); ?>
				</th>
                <th width="10%" class="title">
                    <?php echo JHTML::_('grid.sort',   'Group', 'u.usertype', @$filter_order_Dir, @$filter_order ); ?>
                </th>
	 			<th width="5%" class="title">
                    <?php echo JHTML::_('grid.sort',   'Enabled', 'u.block', @$filter_order_Dir, @$filter_order ); ?>
                 </th>
			</tr>
		</thead>
        <tfoot>
			<tr>
				<td colspan="6">
					<?php echo $pagination->getListFooter(); ?>
				</td>
			</tr>
		 </tfoot>
        <?php
			$k = 0;
			for ($i=0, $n=count( $users ); $i < $n; $i++)
			{
				$row 	= $users[$i];

				$img 	= $row->block ? 'publish_x.png' : 'tick.png';
				$task 	= $row->block ? 'publish' : 'unpublish';
				$alt 	= $row->block ? JText::_( 'UnPublic' ) : JText::_( 'Public' );

			?>
			<tr class="<?php echo "row$k"; ?>">
				<td>
					<?php echo $i+1+$pagination->limitstart;?>
				</td>
				<td style="color:#0B55C4">
					<?php echo $row->name; ?>
				</td>
				<td>
                    <?php echo $row->username; ?>
				</td>
                <td style="color:#0B55C4">
                	<?php echo $row->email; ?>
				</td>
                <td>
                    <?php echo $row->usertype; ?>
				</td>
				<td align="center">
						<img src="images/<?php echo $img;?>" width="16" height="16" border="0" alt="<?php echo $alt; ?>" />
				</td>
			</tr>
			<?php
				$k = 1 - $k;
				}
			?>
    </table>
    <?php
	}else{
		echo "<b>There isn't any users like filtering</b>";
	}
	die();
  }
  function publishField($task){
		$model = &JModel::getInstance( 'cb_reportComponentModel' );
		$model->publishField($task);
		$id		= JRequest::getVar('id',0);
		$this->setRedirect( 'index.php?option=com_cb_report&controller=cb_report&task=configure_display&id='.$id);
  }
  function orderFields($fid, $inc){
		$model = &JModel::getInstance( 'cb_reportComponentModel' );
		$model->orderFields($fid, $inc);
		$id		= JRequest::getVar('id',0);
		$this->setRedirect( 'index.php?option=com_cb_report&controller=cb_report&task=configure_display&id='.$id);
   }
   function orderAllFields($order){
		$model = &JModel::getInstance( 'cb_reportComponentModel' );
		$model->orderAllFields($order);
		$id		= JRequest::getVar('id',0);
		$this->setRedirect( 'index.php?option=com_cb_report&controller=cb_report&task=configure_display&id='.$id);
   }
   function testMail(){
		$model = &JModel::getInstance( 'cb_reportComponentModel' );
		$model->testMail();
		die();
   }
   function sendMail(){
		$model = &JModel::getInstance( 'cb_reportComponentModel' );
		$model->sendMail();
		die();
   }
	
}
?>
