<?php
/*------------------------------------------------------------------------
# com_cb_report - Create User Report for Community Builder
# ------------------------------------------------------------------------
# author    Vsmart Extensions
# copyright Copyright (C) 2010 www.vsmart-extensions.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.vsmart-extensions.com
# Technical Support:  Forum - http://www.vsmart-extensions.com
-------------------------------------------------------------------------*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );
class cb_reportConfigController extends JController
{

	/**
	 * Custom Constructor
	 */
	//DEVNOTE: register task - Register (map) a task to a method in the class
	//function registerTask( $task, $method )
	function __construct( $default = array())
	{
		parent::__construct( $default );
	}
	function execute($task){
		switch($task){
			case "publish":
			case "unpublish":
				$this->publish($task);
				break;
			case "publish_report":
			case "unpublish_report":
				$this->publishInReport($task);
				break;
			case "orderupField":
				$cid        = JRequest::getVar( 'cid', array(), 'post', 'array' );
				$this->orderFields( $cid[0], -1);
				break;
			case "orderdownField":
				$cid        = JRequest::getVar( 'cid', array(), 'post', 'array' );
				$this->orderFields( $cid[0], 1);
				break;
			case "savefieldorder":
				$order      = JRequest::getVar( 'order', array(), 'post', 'array' );
				$this->orderAllFields($order);
				break;
			default:
				$this->display();
				break;
		}
	}
	
	function display() {
	   $model = &JModel::getInstance( 'cb_reportConfigComponentModel' );
	   $model->importCBFields();
	   $model->getCBFields();
	   $view = new cb_reportConfigComponentView( );
	   $view->setModel( $model, true );
	   $view->display();
  	}
	function publish($task){
		$model = &JModel::getInstance( 'cb_reportConfigComponentModel' );
		$model->publish($task);
		$msg = JText::sprintf( 'Successfully Updated Items');
		$this->setRedirect( 'index.php?option=com_cb_report&controller=config', $msg );
    }
	function publishInReport($task){
		$model = &JModel::getInstance( 'cb_reportConfigComponentModel' );
		$model->publishInReport($task);
		$msg = JText::sprintf( 'Successfully Updated Items');
		$this->setRedirect( 'index.php?option=com_cb_report&controller=config', $msg );
    }
	function orderFields($fid, $inc){
		$model = &JModel::getInstance( 'cb_reportConfigComponentModel' );
		$model->orderFields($fid, $inc);
		$msg = JText::sprintf( 'Successfully Updated Items');
		$this->setRedirect( 'index.php?option=com_cb_report&controller=config', $msg );
	}
	function orderAllFields($order){
		$model = &JModel::getInstance( 'cb_reportConfigComponentModel' );
		$model->orderAllFields($order);
		$msg = JText::sprintf( 'Successfully Updated Items');
		$this->setRedirect( 'index.php?option=com_cb_report&controller=config', $msg );
	}
}
?>
