<?php
/*------------------------------------------------------------------------
# com_cb_report - Create User Report for Community Builder
# ------------------------------------------------------------------------
# author    Vsmart Extensions
# copyright Copyright (C) 2010 www.vsmart-extensions.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.vsmart-extensions.com
# Technical Support:  Forum - http://www.vsmart-extensions.com
-------------------------------------------------------------------------*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.model' );

class cb_reportComponentModel extends JModel
{
	/** @var object JTable object */
	var $_table = '#__cb_report';
	var $lists;
	var $items;
	var $pagination;

	/**
	 * Returns the internal table object
	 * @return JTable
	 */
	function &getTable()
	{
		if ($this->_table == null) {
			$this->_table = JTable::getInstance('component', $this->getDBO() );
		}
		return $this->_table;
	}
	function &getListItem(){
		global $mainframe, $option;
		
		$db =& JFactory::getDBO();
		$search				= $mainframe->getUserStateFromRequest( "$option.search",			'search', 			'',			'string' );
		$filter_category	= $mainframe->getUserStateFromRequest( "$option.filter_category",	'filter_category', 		4,			'string' );
		
		//$filter_order		= $mainframe->getUserStateFromRequest( $option.'.filter_order',		'filter_order',		'a.id',	'cmd' );
		//$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		
		$filter_order		= JRequest::getVar( 'filter_order', 'a.id', 'post', 'string' );
		$filter_order_Dir	= JRequest::getVar( 'filter_order_Dir', 'asc', 'post', 'string' );
		
		$search				= JString::strtolower( $search );

		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );
		
		$order 			= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', a.id';
		

		$where = array();
		
		if (isset( $search ) && $search!= '')
		{
			$searchEscaped = $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'a.title LIKE '.$searchEscaped;
		}
		
		if ( $filter_category != 4 )
		{
			$where[] = ' a.access = \''.$filter_category.'\'';
		}

		$where = ( count( $where ) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );

		$query = 'SELECT COUNT(a.id)'
		. ' FROM #__cb_report AS a'
		. $where
		;
		$db->setQuery( $query );
		$total = $db->loadResult();

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $total, $limitstart, $limit );
		
		$query = 'SELECT a.*,g.name as access_level '
			. ' FROM #__cb_report AS a JOIN #__groups as g on a.access = g.id '
			. $where
			//. ' ORDER BY a.title';
			.$order;
		$db->setQuery( $query, $pagination->limitstart, $pagination->limit );
		$rows = $db->loadObjectList();
		
		$lists['search']= $search;
		
		$query = 'SELECT a.id AS value, a.name AS text '
		. ' FROM #__groups AS a '
		. ' ORDER BY a.id'
		;

		$db->setQuery( $query );
		
		$types[] 		= JHTML::_('select.option',  '4', '- '. JText::_( 'Select Access Level' ) .' -' );
		foreach( $db->loadObjectList() as $obj )
		{
			$types[] = JHTML::_('select.option',  $obj->value, JText::_( $obj->text ) );
		}
		$lists['category'] 	= JHTML::_('select.genericlist',   $types, 'filter_category', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', "$filter_category" );
		
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order']		= $filter_order;

		$this->lists = $lists;
		
		$this->items = $rows;
		
		$this->pagination = $pagination;
		
	}
	function publish($task){

		$db 		=& JFactory::getDBO();
		
		if($task == "publish")
			$public = 1;
		else
			$public = 0;
			
		$cid        = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$cids = implode ( ',', $cid );
		
	  	$db->setQuery ( "UPDATE #__cb_report SET `public`='$public'"
		  . "\nWHERE id IN ($cids)"
		);
		if ( !$db->query ( ) )
		{
		  echo "<script> alert('".$db->getErrorMsg ( )."'); window.history.go(-1); </script>\n";
		  exit();
		}
	}
	function &getItem($id=0){
	
		$cid		= JRequest::getVar( 'cid', array(0), '', 'array' );
		if($cid[0] =="")
			$cid[0] = $id;
		$edit		= JRequest::getVar('edit',true);
		JArrayHelper::toInteger($cid, array(0));
		
		$db 		=& JFactory::getDBO();
		
		$query = 'SELECT * FROM #__cb_report WHERE id="'.$cid[0].'"';
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$row = $rows[0];
		return $row;
	}
	function getPublishState($id){
		$db 		=& JFactory::getDBO();
		$query = 'SELECT `public` FROM #__cb_report WHERE id="'.$id.'"';
		$db->setQuery($query);
		$publish = $db->loadResult();
		return $publish;
	}
	function getAccessLevel($id){
		$db 		=& JFactory::getDBO();
		
		$query = 'SELECT `access` FROM #__cb_report WHERE id="'.$id.'"';
		$db->setQuery($query);
		$access_level = $db->loadResult();
		
		
		
		return $access_level;
	}
	function getUsers($data,$fields,&$pagination,$is_pagination = true){
		global $mainframe, $option;
		
		$filter_order		= JRequest::getVar( 'filter_order', 'u.name', 'post', 'string' );
		$filter_order_Dir	= JRequest::getVar( 'filter_order_Dir', 'asc', 'post', 'string' );
		
		$limit		= JRequest::getVar( 'limit', $mainframe->getCfg('list_limit'), 'post', 'string' );
		$limitstart	= JRequest::getVar( 'limitstart', 0, 'post', 'string' );
		$db 		=& JFactory::getDBO();
		if($filter_order !="" && $filter_order_Dir !="")
			$order 			= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', u.name';
		else
			$order 			= ' ORDER BY u.name';
		
		$where = array();
		$searchEscaped = "";
		if($data["gid"] !="" && $data["gid"] !="null"){
			$where[] = 'u.gid in ('.$data["gid"].')';
		}
		//search data
		for($i=0;$i<count($fields);$i++){
			$field = $fields[$i];
			$searchText = "";
			if($data[$field->name] !="" && $data[$field->name] ){
				$searchWords = explode(",",$data[$field->name]);
				for($k=0;$k<count($searchWords);$k++){
					$searchword = $searchWords[$k];
					if(trim($searchword) !=""){
						$searchEscaped = $db->Quote( '[[:<:]]'.$db->getEscaped( trim($searchword), true ).'[[:>:]]', false );
						if($searchText !=""){
							$searchText .= " OR ".$field->name.' RLIKE '.$searchEscaped;
						}else{
							$searchText .= $field->name.' RLIKE '.$searchEscaped;
						}
					}
				}
				
				//$where[] = $field->name.' RLIKE '.$searchEscaped;
				if($searchText != "") $where[] = $searchText;
			}
		}
		$where = ( count( $where ) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );
		//print_r($where);
		$query = 'SELECT count(u.id) '
			. ' FROM #__users AS u JOIN #__comprofiler as c on u.id = c.user_id '
			. $where;
		$db->setQuery( $query );
		$total = $db->loadResult();
		jimport('joomla.html.pagination');

		$pagination = new JPagination( $total, $limitstart, $limit );
		
		$query = 'SELECT u.*,c.* '
			. ' FROM #__users AS u JOIN #__comprofiler as c on u.id = c.user_id '
			. $where
			//. ' ORDER BY u.name';
			.$order;
		if($is_pagination == "")
			$db->setQuery( $query);
		else
			$db->setQuery( $query, $pagination->limitstart, $pagination->limit);
		$rows = $db->loadObjectList();
		
		if($is_pagination != ""){
			for($i=0;$i<count($rows);$i++){
				for($j=0;$j<count($fields);$j++){
					$field = $fields[$j];
					$searchText = "";
					if($data[$field->name] !="" && $data[$field->name] ){
						$searchWords = explode(",",$data[$field->name]);
						for($k=0;$k<count($searchWords);$k++){
							$searchword = $searchWords[$k];
							if(trim($searchword) !=""){
								$rows[$i]->{$field->name} = str_replace(trim($searchword),'<span style="background-color:#FFFF00">'.$searchword.'</span>',$rows[$i]->{$field->name});
							}
						}
					}//end if
				}//end for $j
				
			}//end for $i
		}
		return $rows;
	}
	function getSearchDate($id){
		$db 		=& JFactory::getDBO();
		
		$query = "SELECT fr.value as value, cf.name as name FROM #__cb_field_report as fr JOIN #__comprofiler_fields as cf ON fr.field_id = cf.fieldid  WHERE report_id=$id";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$data = array();
		for($i=0;$i<count($rows);$i++){
			$data[$rows[$i]->name] = $rows[$i]->value;
		}
		return $data;
	}
	function deleteListItem(){
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		
		$db 		=& JFactory::getDBO();
		
		for($i=0;$i<sizeof($cid);$i++){

			$id = $cid[$i];
			//start delete
			$sql = "DELETE FROM #__cb_report WHERE id = '".$id."'";
			$db->setQuery($sql);
			$db->query();
			
			$sql = "DELETE FROM #__cb_field_report WHERE report_id = '".$id."'";
			$db->setQuery($sql);
			$db->query();
			
		}
	}
	function saveReport($fields){
	
		global $mainframe;
		
		$id		= JRequest::getVar('id',0);
		
		//Save data
		$data = JRequest::get('post');
		
		$gid = $data["gid"];
		
		if(count($gid) > 0)
			$gid = implode(",", $gid);
		else
			$gid = "";
			
		if (empty($id) || $id == 0){
			$now =& JFactory::getDate();
			$date_created = $now->toMySQL();
			
		}else{
			$now =& JFactory::getDate();
			$last_modify = $now->toMySQL();
		}
		
		$db 	=& JFactory::getDBO();
		
		if($id != 0){
			$sql = "UPDATE #__cb_report SET ".
					"cb_groups = '".$gid."',".
					"last_modify = '".$last_modify."'".
					" WHERE id = '".$id."'"; 
		}else{
			$sql = "INSERT INTO #__cb_report SET ".
					"cb_groups = '".$gid."',".
					"date_created = '".$date_created."',".
					"last_modify = '".$date_created."'";
			
		}
		$db->setQuery($sql);
		$return = $db->query();
		
		if($id == 0 )
			$id = $db->insertid();
			
		for($i=0;$i<count($fields);$i++){
			$field = $fields[$i];
			$value = $db->getEscaped( $data[$field->name], true );
			$query = "SELECT report_id FROM #__cb_field_report WHERE report_id=$id AND field_id = $field->fieldid";
			$db->setQuery($query);
			$result = $db->loadResult();
			if($result){
				$sql = "UPDATE #__cb_field_report SET ".
				"value = '".$value."'".
				" WHERE report_id=$id AND field_id = $field->fieldid";
				$db->setQuery($sql);
				$db->query();
			}else{
				if($value !=""){
					$sql = "INSERT INTO #__cb_field_report SET ".
					"report_id = '".$id."',".
					"field_id = '".$field->fieldid."',".
					"value = '".$value."'";
					$db->setQuery($sql);
					$db->query();
				}
			}
		}
		
		return $id;
	}
	function saveCompleteReport(){
		global $mainframe;
		
		$db = &JFactory::getDBO();
		
		$id		= JRequest::getVar('id',0);
		
		//Save data
		$data = JRequest::get('post');
		
		$sql = "UPDATE #__cb_report SET ".
					"access = '".$data["access"]."',".
					"title = '".$db->getEscaped($data["title"])."'".
					" WHERE id = '".$id."'";
					
		$db->setQuery($sql);
		$return = $db->query(); 
	}
	function getDisplayFields($fields,$id,$display=0){
	
		$filter_order		= JRequest::getVar( 'filter_order_field', 'f.ordering', 'post', 'string' );
		$filter_order_Dir	= JRequest::getVar( 'filter_order_Dir_field', 'asc', 'post', 'string' );
		
		$order 			= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', f.ordering';
	
		$db 		=& JFactory::getDBO();
		
		foreach($fields as $row){
			$query = "SELECT report_id FROM #__cb_configure_report WHERE field_id = $row->fieldid AND report_id = $id";
			$db->setQuery($query);
			$report_id = $db->loadResult();
			if(!$report_id){
				$query = "INSERT INTO #__cb_configure_report SET report_id=$id,field_id = $row->fieldid,ordering = $row->ordering";
				$db->setQuery($query);
				$db->query();
			}
		}
		if(!$display)
			$query = "SELECT a.*,f.*,f.ordering as ordering FROM #__comprofiler_fields as a JOIN #__cb_configure_report as f on a.fieldid = f.field_id JOIN #__cb_configure as c ON c.cb_field_id = f.field_id WHERE report_id = $id AND c.reportable = 1 ".$order;
		else
			$query = "SELECT a.*,f.*,f.ordering as ordering FROM #__comprofiler_fields as a JOIN #__cb_configure_report as f on a.fieldid = f.field_id JOIN #__cb_configure as c ON c.cb_field_id = f.field_id WHERE report_id = $id AND display = 1 AND c.reportable = 1 ".$order;
			//echo $query;
		
		$db->setQuery( $query);
		$rows = $db->loadObjectList();
		
		for($i=0;$i<count($rows);$i++){
			$rows[$i]->title = getLangDefinition($rows[$i]->title);
		}
		if($filter_order == "a.title"){
			if($filter_order_Dir == "asc"){
				$rows = vsort($rows,'title', true, true);
			}else{
				$rows = vsort($rows,'title', false, true);
			}
		} 
	
		return $rows;
	}
	function publishField($task){

		$db 		=& JFactory::getDBO();
		
		$id		= JRequest::getVar('id',0);
		
		if($task == "publishField")
			$display = 1;
		else
			$display = 0;
			
		$cid        = JRequest::getVar( 'did', array(), 'post', 'array' );
		$cids = implode ( ',', $cid );
		
	  	$db->setQuery ( "UPDATE #__cb_configure_report SET display='$display'"
		  . "\nWHERE field_id IN ($cids) AND report_id = $id"
		);
		if ( !$db->query ( ) )
		{
		  echo "<script> alert('".$db->getErrorMsg ( )."'); window.history.go(-1); </script>\n";
		  exit();
		}
	}
	function exportCvs(){
	
		$db 		=& JFactory::getDBO();
		
		$id		= JRequest::getVar('id',0);
		
		$report = $this->getItem($id);
		$date_modify = str_replace("-","_",$report->last_modify);
		$date_modify = str_replace(":","_",$date_modify);
		$date_modify = str_replace(" ","_",$date_modify);
		$title = str_replace(" ","_",$report->title);
		$title = str_replace("-","_",$title);
		$file_name = $title."_".$date_modify;
		
		//Get Users
		$data   = $this->getSearchDate($report->id);
	    $data["gid"] = $report->cb_groups;
		
		$modelConfig = &JModel::getInstance( 'cb_reportConfigComponentModel' );
		$fields = $modelConfig->getAllCBFields();
		$pagination = "";
	    $users = $this->getUsers($data,$fields,$pagination,false);
		
		//Get Display Fields
		$fields2 = $modelConfig->getAllCBFields2();
		$display_fields = $this->getDisplayFields($fields2,$id,1);
		
		header( "Content-Type: application/save-as" );
		header ('Content-Disposition: attachment; filename="'.$file_name.'.csv"');
		$content =  "";
		$k=0;
		foreach ($display_fields as $field){
			$content .= htmlspecialchars( getLangDefinition($field->title) );
			$k++;
			if($k!=count($display_fields))
				$content .=",";
		}
		$content .= "\r\n";
		$i = 0;
		foreach ($users as $user){
			$k=0;
			foreach ($display_fields as $field){
				$name = $field->name;
				$content .= htmlspecialchars(str_replace("\n"," ",$user->{$name}));
				$k++;
				if($k!=count($display_fields))
					$content .=",";
			}
			$content .= "\r\n";
		}
		echo $content;
		die();
	}
	function viewReport(){
		$db 		=& JFactory::getDBO();
		
		$id		= JRequest::getVar('id',0);
		
		$report = $this->getItem($id);
		//Get Users
		$data   = $this->getSearchDate($report->id);
	    $data["gid"] = $report->cb_groups;
		
		$modelConfig = &JModel::getInstance( 'cb_reportConfigComponentModel' );
		$fields = $modelConfig->getAllCBFields();
	    $users = $this->getUsers($data,$fields,$pagination);
		
		//Get Display Fields
		$fields2 = $modelConfig->getAllCBFields2();
		$display_fields = $this->getDisplayFields($fields2,$id,1);
		
		?>
        	<div style="overflow:auto;">
            <table class="adminlist" cellpadding="0" width="100%" cellspacing="0">
                <thead>
                    <tr>
                        <th width="2%" class="title">
                            <?php echo JText::_( 'NUM' ); ?>
                        </th>
                        <?php
                            foreach ($display_fields as $field){
                                echo "<th class='title'>".htmlspecialchars( getLangDefinition($field->title) )."</th>";
                            }
                        ?>
                    </tr>
                </thead>
                <?php
					$i = 0;
					$k = 0;
					foreach ($users as $user){
						echo "<tr class='row".$k."'>";
						echo "<td>".($pagination->limitstart + $i + 1)."</td>";
						foreach ($display_fields as $field){
							$name = $field->name;
							$value = $user->{$name};
							echo "<td>".$value."</td>";
						}
						echo "</tr>";
						$i ++;
						$k = 1 - $k;
				  }
				?>
            </table>
            </div>
            <div style="margin:10px auto;">
            	<?php echo $pagination->getListFooter(); ?>
            </div>
		<?php
		die();
	}
	function orderFields($fid, $inc) {
	
		$db 		=& JFactory::getDBO();
		
		$id		= JRequest::getVar('id',0);
		//
		$query = "SELECT f.* FROM #__cb_configure_report as f JOIN #__cb_configure as c ON c.cb_field_id = f.field_id WHERE f.report_id = $id and c.reportable = 1  order by f.ordering";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$near_id = 0;
		for($i=0;$i<count($rows);$i++){
			if($rows[$i]->field_id == $fid){
				$ordering = $rows[$i]->ordering;
				$near_id = $rows[$i+$inc]->field_id;
				$near_ordering = $rows[$i+$inc]->ordering;
				break;
			}
		}
		
		$db->setQuery ( "UPDATE #__cb_configure_report SET ordering= $ordering "
		  . "\nWHERE field_id = $near_id AND report_id = $id "
		);
		if ( !$db->query ( ) )
		{
		  echo "<script> alert('".$db->getErrorMsg ( )."'); window.history.go(-1); </script>\n";
		  exit();
		}
		//
		$db->setQuery ( "UPDATE #__cb_configure_report SET ordering= $near_ordering "
		  . "\nWHERE field_id = $fid AND report_id = $id "
		);
		if ( !$db->query ( ) )
		{
		  echo "<script> alert('".$db->getErrorMsg ( )."'); window.history.go(-1); </script>\n";
		  exit();
		}
	
	}
	function orderAllFields($order) {
	
		$db 		=& JFactory::getDBO();
		
		$id		= JRequest::getVar('id',0);
		
		//
		$query = "SELECT f.* FROM #__cb_configure_report as f JOIN #__cb_configure as c ON c.cb_field_id = f.field_id WHERE f.report_id = $id and c.reportable = 1  order by f.ordering";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		for($i=0;$i<count($rows);$i++){
			$ordering = $order[$i];
			$field_id = $rows[$i]->field_id;
			$db->setQuery ( "UPDATE #__cb_configure_report SET ordering= $ordering "
			  . "\nWHERE field_id = $field_id AND report_id = $id "
			);
			if ( !$db->query ( ) ){
			  /*echo "<script> alert('".$db->getErrorMsg ( )."'); window.history.go(-1); </script>\n";
			  /exit();*/
			  echo "UPDATE #__cb_configure_report SET ordering= $ordering "
			  . "\nWHERE field_id = $field_id AND report_id = $id";
			}
		}
	}
	function testMail(){
		global $mainframe;
		
		$db 		=& JFactory::getDBO();
		
		$user = &JFactory::getUser();
		
		
		$id				= JRequest::getVar('id',0);
		$subject        = JRequest::getVar( 'subject', '');
		$testmail        = JRequest::getVar( 'testmail', '');
		$message		= JRequest::getVar('message', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$sign		    = JRequest::getVar('sign', '', 'post', 'string', JREQUEST_ALLOWRAW);
		
		
		$MailFrom 	= $mainframe->getCfg('mailfrom');
		$FromName 	= $mainframe->getCfg('fromname');

		// Prepare email body
		$body 	= stripslashes($message)."\r\n\r\n"."<br><br>".stripslashes($sign);

		$mail = JFactory::getMailer();

		$mail->addRecipient( $testmail );
		$mail->setSender( array( $user->email, $user->name ) );
		//$mail->setSender( array( $MailFrom, $FromName ) );
		$mail->setSubject( $FromName.': '.$subject );
		$mail->setBody( $body );

		$sent = $mail->Send();
		if($sent)
			echo "Successfully sent email";
		else
			echo "Send email fail";
	}
	function sendMail(){
		global $mainframe;
		
		$db 		=& JFactory::getDBO();
		
		$user = &JFactory::getUser();
		
		$id		= JRequest::getVar('id',0);
		
		$subject        = JRequest::getVar( 'subject', '');
		$message		= JRequest::getVar('message', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$sign		    = JRequest::getVar('sign', '', 'post', 'string', JREQUEST_ALLOWRAW);
		
		$query = "SELECT * FROM #__cb_configure_email";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$emailConfig = $rows[0];
		
		$MailFrom 	= $mainframe->getCfg('mailfrom');
		$FromName 	= $mainframe->getCfg('fromname');

		// Prepare email body
		$body 	= stripslashes($message)."\r\n\r\n"."<br><br>".stripslashes($sign);

		$mail = JFactory::getMailer();

		$mail->addRecipient( $emailConfig->email_admin );
		$mail->setSender( array( $MailFrom, $FromName ) );
		//$mail->setSubject( $FromName.': '.$subject );
		$mail->setSender( array( $user->email, $user->name ) );
		$mail->setBody( $body );
		$sent = $mail->Send();
		
		//Sent mail to users in report
		$report = $this->getItem($id);
		
		//Get Users
		$data   = $this->getSearchDate($report->id);
	    $data["gid"] = $report->cb_groups;
		
		$modelConfig = &JModel::getInstance( 'cb_reportConfigComponentModel' );
		$fields = $modelConfig->getAllCBFields();
		$pagination = "";
	    $users = $this->getUsers($data,$fields,$pagination,false);
		
		$total = count($users);
		$number = intval($total/10);
		$less = $total%10;
		$emails = array();
		for($i=0;$i<$number;$i++){
			for($j=0;$j<10;$j++){
				$emails[$j] = $users[(10*$i)+$j]->email;
			}
			$mail = JFactory::getMailer();
			$mail->addRecipient( $emails );
			//$mail->setSender( array( $MailFrom, $FromName ) );
			$mail->setSender( array( $user->email, $user->name ) );
			$mail->setSubject( $FromName.': '.$subject );
			$mail->setBody( $body );
			$sent = $mail->Send();
		}
		$n = ($number*10);
		$less_emails = array();
		$k=0;
		for($i=$n;$i<total;$i++){
			$less_emails[$k] = $users[$i]->email;
			$k++;
		}
		$mail = JFactory::getMailer();
		$mail->addRecipient( $less_emails );
		//$mail->setSender( array( $MailFrom, $FromName ) );
		$mail->setSender( array( $user->email, $user->name ) );
		$mail->setSubject( $FromName.': '.$subject );
		$mail->setBody( $body );
		$sent = $mail->Send();
		
		/* for($i=0;$i<count($users);$i++){
				$mail = JFactory::getMailer();
				$mail->addRecipient( $users[$i]->email );
				$mail->setSender( array( $user->email, $user->name ) );
				$mail->setSubject( $FromName.': '.$subject );
				$mail->setBody( $body );
				$sent = $mail->Send();
		} */
		
		if($sent)
			echo "Successfully sent email";
		else
			echo "Send email fail";
	}
}

?>
