<?php
/*------------------------------------------------------------------------
# com_cb_report - Create User Report for Community Builder
# ------------------------------------------------------------------------
# author    Vsmart Extensions
# copyright Copyright (C) 2010 www.vsmart-extensions.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.vsmart-extensions.com
# Technical Support:  Forum - http://www.vsmart-extensions.com
-------------------------------------------------------------------------*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class cb_reportConfigComponentModel extends JModel
{
	/** @var object JTable object */
	var $_table = '#__cb_configure';

	var $items;
	var $pagination;
	var $lists;

	/**
	 * Returns the internal table object
	 * @return JTable
	 */
	function &getTable()
	{
		if ($this->_table == null) {
			$this->_table = JTable::getInstance('component', $this->getDBO() );
		}
		return $this->_table;
	}

	/**
	 * Get the params for the configuration variables
	 */
	function &getCBFields(){
		global $mainframe, $option;
		
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );
		
		$filter_order		= JRequest::getVar( 'filter_order', 'f.ordering', 'post', 'string' );
		$filter_order_Dir	= JRequest::getVar( 'filter_order_Dir', 'asc', 'post', 'string' );
		
		$order 			= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', f.ordering';
		
		
		$db 		=& JFactory::getDBO();
		
		$where = array();
		
		$where[] = 'a.published = 1';
		
		$where = ( count( $where ) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );
		
		$query = 'SELECT COUNT(a.fieldid)'
		. ' FROM #__comprofiler_fields AS a JOIN #__cb_configure as f on a.fieldid = f.cb_field_id'
		. $where
		;
		$db->setQuery( $query );
		$total = $db->loadResult();

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $total, $limitstart, $limit );
		
		$query = 'SELECT a.*,f.searchable as searchable,f.ordering as ordering,f.reportable FROM #__comprofiler_fields as a JOIN #__cb_configure as f on a.fieldid = f.cb_field_id'.$where.$order;
		$db->setQuery( $query, $pagination->limitstart, $pagination->limit );
		$rows = $db->loadObjectList();

		
		for($i=0;$i<count($rows);$i++){
			$rows[$i]->title = getLangDefinition($rows[$i]->title);
		}
		if($filter_order == "a.title"){
			if($filter_order_Dir == "asc"){
				$rows = vsort($rows,'title', true, true);
			}else{
				$rows = vsort($rows,'title', false, true);
			}
		} 
		
		$this->items = $rows;
		
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order']		= $filter_order;

		$this->lists = $lists;
		
		$this->pagination = $pagination;
	}
	function &importCBFields(){
		$db 		=& JFactory::getDBO();
		$query = 'SELECT a.fieldid as id ,a.ordering as ordering FROM #__comprofiler_fields as a WHERE a.published = 1';
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		foreach($rows as $row){
			$query = "SELECT cb_field_id FROM #__cb_configure WHERE cb_field_id = $row->id";
			$db->setQuery($query);
			$cb_field_id = $db->loadResult();
			if(!$cb_field_id){
				$query = "INSERT INTO #__cb_configure SET cb_field_id = $row->id,ordering = $row->ordering";
				$db->setQuery($query);
				$db->query();
			}
		}
		
	}
	function publish($task){

		$db 		=& JFactory::getDBO();
		
		if($task == "publish")
			$searchable = 1;
		else
			$searchable = 0;
			
		$cid        = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$cids = implode ( ',', $cid );
		
	  	$db->setQuery ( "UPDATE #__cb_configure SET searchable='$searchable'"
		  . "\nWHERE cb_field_id IN ($cids)"
		);
		if ( !$db->query ( ) )
		{
		  echo "<script> alert('".$db->getErrorMsg ( )."'); window.history.go(-1); </script>\n";
		  exit();
		}
	}
	function publishInReport($task){

		$db 		=& JFactory::getDBO();
		
		if($task == "publish_report")
			$reportable = 1;
		else
			$reportable = 0;
			
		$cid        = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$cids = implode ( ',', $cid );
		
	  	$db->setQuery ( "UPDATE #__cb_configure SET reportable='$reportable'"
		  . "\nWHERE cb_field_id IN ($cids)"
		);
		if ( !$db->query ( ) )
		{
		  echo "<script> alert('".$db->getErrorMsg ( )."'); window.history.go(-1); </script>\n";
		  exit();
		}
	}
	function orderFields($fid, $inc) {
	
		$db 		=& JFactory::getDBO();
		
		//
		$query = "SELECT * FROM #__cb_configure order by ordering";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$near_id = 0;
		for($i=0;$i<count($rows);$i++){
			if($rows[$i]->cb_field_id == $fid){
				$ordering = $rows[$i]->ordering;
				$near_id = $rows[$i+$inc]->cb_field_id;
				$near_ordering = $rows[$i+$inc]->ordering;
				break;
			}
		}
		$db->setQuery ( "UPDATE #__cb_configure SET ordering= $ordering "
		  . "\nWHERE cb_field_id = $near_id"
		);
		if ( !$db->query ( ) )
		{
		  echo "<script> alert('".$db->getErrorMsg ( )."'); window.history.go(-1); </script>\n";
		  exit();
		}
		//
		$db->setQuery ( "UPDATE #__cb_configure SET ordering= $near_ordering "
		  . "\nWHERE cb_field_id = $fid"
		);
		if ( !$db->query ( ) )
		{
		  echo "<script> alert('".$db->getErrorMsg ( )."'); window.history.go(-1); </script>\n";
		  exit();
		}
	
	}
	function orderAllFields($order) {
	
		$db 		=& JFactory::getDBO();
		
		//
		$query = "SELECT * FROM #__cb_configure order by ordering";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		for($i=0;$i<count($rows);$i++){
			$ordering = $order[$i];
			$cb_field_id = $rows[$i]->cb_field_id;
			$db->setQuery ( "UPDATE #__cb_configure SET ordering= $ordering "
			  . "\nWHERE cb_field_id = $cb_field_id"
			);
			if ( !$db->query ( ) ){
			  /*echo "<script> alert('".$db->getErrorMsg ( )."'); window.history.go(-1); </script>\n";
			  //exit();*/
			  echo "UPDATE #__cb_configure SET ordering= $ordering "
			  . "\nWHERE cb_field_id = $cb_field_id";
			}
		}
	}
	function &getAllCBFields(){
		global $mainframe, $option;
		
		$db 		=& JFactory::getDBO();
		
		$where = array();
		
		$where[] = 'a.published = 1';
		$where[] = 'f.searchable = 1';
		
		$where = ( count( $where ) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );
		
		$query = 'SELECT a.*,f.searchable as searchable,f.ordering as ordering FROM #__comprofiler_fields as a JOIN #__cb_configure as f on a.fieldid = f.cb_field_id'.$where." ORDER BY f.ordering";
		$db->setQuery( $query);
		$rows = $db->loadObjectList();
		return $rows;
	}
	function &getAllCBFields2(){
		global $mainframe, $option;
		
		$db 		=& JFactory::getDBO();
		
		$where = array();
		
		$where[] = 'a.published = 1';
		$where[] = 'f.reportable = 1';
		
		$where = ( count( $where ) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );
		
		$query = 'SELECT a.*,f.reportable,f.ordering as ordering FROM #__comprofiler_fields as a JOIN #__cb_configure as f on a.fieldid = f.cb_field_id'.$where." ORDER BY f.ordering";
		$db->setQuery( $query);
		$rows = $db->loadObjectList();
		return $rows;
	}
	
}
?>
