<?php
/*------------------------------------------------------------------------
# com_cb_report - Create User Report for Community Builder
# ------------------------------------------------------------------------
# author    Vsmart Extensions
# copyright Copyright (C) 2010 www.vsmart-extensions.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.vsmart-extensions.com
# Technical Support:  Forum - http://www.vsmart-extensions.com
-------------------------------------------------------------------------*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );


class cb_reportConfigComponentView extends JView
{
	/**
	 * Display the view
	 */
	 var $items;
	 var $pagination;
	 var $lists;
	 
	function setModel($model){
		$this->items = $model->items;
		$this->pagination = $model->pagination;
		$this->lists = $model->lists;
	}
	function display()
	{
		//DEVNOTE: set document title
		global $mainframe;
		$mosConfig_live_site = $mainframe->getSiteURL();
		
		$document = & JFactory::getDocument();
		$document->setTitle( JText::_('CB Report: Report Preferences') );
		JHTML::_('behavior.tooltip');
    //DEVNOTE: Print Hellpworld and language name
?>
  <script>
  	function cbsaveorder( n ) {
		checkAll( n );
		submitform('savefieldorder');
	}
  </script>
  <div style="padding-bottom:10px;">Select the fields that should be available in the filter when creating new reports.</div>      
  <form action="index.php?option=com_cb_report&controller=config" method="post" name="adminForm">
	<table class="adminlist" cellpadding="1">
		<thead>
			<tr>
				<th width="2%" class="title">
					<?php echo JText::_( 'NUM' ); ?>
				</th>
				<th width="3%" class="title">
					<input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($this->items); ?>);" />
				</th>
				<th width="50%" class="title">
                    <?php echo JHTML::_('grid.sort',   'Title', 'a.title', @$this->lists['order_Dir'], @$this->lists['order'] ); ?>
				</th>
				<th width="15%" class="title" nowrap="nowrap">
                    <?php echo JHTML::_('grid.sort',   'In Filter', 'f.searchable', @$this->lists['order_Dir'], @$this->lists['order'] ); ?>
				</th>
                <th width="15%" class="title" nowrap="nowrap">
                    <?php echo JHTML::_('grid.sort',   'In Reports', 'f.reportable', @$this->lists['order_Dir'], @$this->lists['order'] ); ?>
				</th>
                <th width="6%" class="title"><?php echo JHTML::_('grid.sort',   'Order', 'f.ordering', @$this->lists['order_Dir'], @$this->lists['order'] ); ?> &nbsp;&nbsp;<a href="javascript: cbsaveorder( <?php echo count( $this->items )-1; ?> )"><img src="images/filesave.png" border="0" width="16" height="16" alt="Save Order" /></a></th>
			</tr>
		</thead>
		<tfoot>
			<tr>
				<td colspan="10">
					<?php echo $this->pagination->getListFooter(); ?>
				</td>
			</tr>
		</tfoot>
		<tbody>
		<?php
			$k = 0;
			for ($i=0, $n=count( $this->items ); $i < $n; $i++)
			{
				$row 	=& $this->items[$i];

				$img 	= $row->searchable ? 'tick.png' : 'publish_x.png';
				$task 	= $row->searchable ? 'unpublish' : 'publish';
				$alt 	= $row->searchable ? JText::_( 'UnPublic' ) : JText::_( 'Public' );
				
				$img2 	= $row->reportable ? 'tick.png' : 'publish_x.png';
				$task2 	= $row->reportable ? 'unpublish_report' : 'publish_report';
				$alt2 	= $row->reportable ? JText::_( 'UnPublic' ) : JText::_( 'Public' );

			?>
			<tr class="<?php echo "row$k"; ?>">
				<td align="center">
					<?php echo $i+1+$this->pagination->limitstart;?>
				</td>
				<td align="center">
					<?php echo JHTML::_('grid.id', $i, $row->fieldid ); ?>
				</td>
				<td>
                    <?php echo htmlspecialchars( $row->title ); ?>
				</td>
				<td align="center">
					<a href="javascript:void(0);" onclick="return listItemTask('cb<?php echo $i;?>','<?php echo $task;?>')">
						<img src="images/<?php echo $img;?>" width="16" height="16" border="0" alt="<?php echo $alt; ?>" /></a>
				</td>
                <td align="center">
					<a href="javascript:void(0);" onclick="return listItemTask('cb<?php echo $i;?>','<?php echo $task2;?>')">
						<img src="images/<?php echo $img2;?>" width="16" height="16" border="0" alt="<?php echo $alt2; ?>" /></a>
				</td>
				<td class="order">
				<?php    if ($i > 0 || ($i+$this->pagination->limitstart > 0)) { ?>
                	<span>
                     <a href="#reorder" onClick="return listItemTask('cb<?php echo $i;?>','orderupField')">
                        <img src="images/uparrow.png" width="12" height="12" border="0" alt="Move Up" />
                     </a>
                     </span>
                <?php    }else{ echo "<span>&nbsp;</span>";} ?>
                <?php    if ($i < $n-1 || $i+$this->pagination->limitstart < $this->pagination->total-1) { ?>
                	<span>
                     <a href="#reorder" onClick="return listItemTask('cb<?php echo $i;?>','orderdownField')">
                        <img src="images/downarrow.png" width="12" height="12" border="0" alt="Move Down" />
                     </a>
                     </span>
                <?php    }else{ echo "<span>&nbsp;</span>";} ?>
                  <input type="text" name="order[]" size="5" value="<?php echo htmlspecialchars( $row->ordering ); ?>" class="text_area" style="text-align: center" />
                  </td>
			</tr>
			<?php
				$k = 1 - $k;
				}
			?>
		</tbody>
	</table>

	<input type="hidden" name="option" value="com_cb_report" />
    <input type="hidden" name="controller" value="config" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="boxchecked" value="0" />
    <input type="hidden" name="filter_order" value="<?php echo $this->lists['order']; ?>" />
	<input type="hidden" name="filter_order_Dir" value="<?php echo $this->lists['order_Dir']; ?>" />
	<?php echo JHTML::_( 'form.token' ); ?>
</form>
<?php 
  }
}
?>
