<?php
/*------------------------------------------------------------------------
# com_cb_report - Create User Report for Community Builder
# ------------------------------------------------------------------------
# author    Vsmart Extensions
# copyright Copyright (C) 2010 www.vsmart-extensions.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.vsmart-extensions.com
# Technical Support:  Forum - http://www.vsmart-extensions.com
-------------------------------------------------------------------------*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

class CBReportController extends JController
{
	/**
	 * Display the view
	 */
	function display()
	{
		
		$document =& JFactory::getDocument();

		$viewName	= JRequest::getVar('view', 'report', 'default', 'cmd');
		$viewType	= $document->getType();


		// interceptors to support legacy urls
		switch ($this->getTask())
		{
			//index.php?option=com_contact&task=category&id=0&Itemid=4
			case 'report':
				$viewName	= 'report';
				$layout		= 'default';
				break;
			case 'detail':
				$viewName	= 'detail';
				$layout		= 'default';
				break;
			case 'sendmail':
				$viewName	= 'sendmail';
				$layout		= 'default';
				break;
		}
		// Set the default view name from the Request
		$view = &$this->getView($viewName, $viewType);

		// Push a model into the view
		$model	= &$this->getModel( $viewName );

		if (!JError::isError( $model )) {
			$view->setModel( $model, true ); 
		}

		// Display the view
		$view->assign('error', $this->getError());
		$view->display();
	}
	function viewReport(){
		global $my;
		$my = &JFactory::getUser();
		$id		= JRequest::getVar('id',0);
		$limit		= JRequest::getVar('limit',50);
		
		$app	= &JFactory::getApplication();
		$router = &$app->getRouter();
		$router->setVar("option","com_cb_report");
		$router->setVar("view","detail");
		$router->setVar("task","");
		$router->setVar("id",$id);
		$router->setVar("limit",$limit);
		
		
		$model = &JModel::getInstance( 'cb_reportComponentModel' );
		$publish = $model->getPublishState($id);
		if(!$publish){
			echo "<div class='warning'>This report isn't public!</div>";
			die();
		}
		$access_level = $model->getAccessLevel($id);
		if($access_level == 0){
			$model->viewReport();
		}else{
			if($access_level == $my->gid || $my->gid == 25)	$model->viewReport();
			else{
				echo "<div class='warning'>This report is protected by access level!</div>";
				die();
			}
		}
	}
	function exportCvs(){
		global $my;
		$my = &JFactory::getUser();
		$id		= JRequest::getVar('id',0);
		
		$model = &JModel::getInstance( 'cb_reportComponentModel' );
		$publish = $model->getPublishState($id);
		if(!$publish){
			echo "<div class='warning'>This report isn't public!</div>";
			die();
		}
		$access_level = $model->getAccessLevel($id);
		if($access_level == 0){
			$model->exportCvs();
		}else{
			if($access_level == $my->gid || $my->gid == 25)	$model->exportCvs();
			else{
				echo "<div class='warning'>This report is protected by access level!</div>";
				die();
			}
		}
	}
	function testMail(){
		$model = &JModel::getInstance( 'cb_reportComponentModel' );
		$model->testMail();
		die();
	}
	function sendMail(){
		$model = &JModel::getInstance( 'cb_reportComponentModel' );
		$model->sendMail();
		die();
	}
	function cancel(){
		global $Itemid;
		$this->setRedirect( 'index.php?option=com_cb_report&Itemi='.$Itemid );
	}
	
}